// RocketFormView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRocketFormView form view

#ifndef __AFXEXT_H__
	#include <afxext.h>
#endif

class CRocketFormView : public CFormView
{
	protected:
		CRocketFormView(); //Protected constructor used by dynamic creation
		DECLARE_DYNCREATE(CRocketFormView)
	
	// Form Data
	public:
		BOOL IsEditCtrl(CWnd* pWnd);
		afx_msg void OnUpdateEditCopyCut(CCmdUI* pCmdUI);
		afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
		afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
		afx_msg void OnEditCopy();
		afx_msg void OnEditCut();
		afx_msg void OnEditPaste();
		afx_msg void OnEditUndo();
		//{{AFX_DATA(CRocketFormView)
		enum { IDD = IDD_MAIN };
		CButton	m_Go;
		CListCtrl	m_ListCtrl;
		double	m_CD;
		double	m_Density;
		int		m_Engine;
		double	m_Mass;
		double	m_Pressure;
		double	m_Radius;
		double	m_Temp;
		double	m_TInc;
		double	m_TEnd;
		double	m_TStart;
		int		m_EndCond;
		double	m_Accuracy;
		//}}AFX_DATA
		double m_TBurn;
		double m_MassF;		
	
	// Attributes
	public:
	
	// Operations
	public:
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRocketFormView)
	public:
		virtual void OnInitialUpdate();
	protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
		virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
		virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
		virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	//}}AFX_VIRTUAL
	
	// Implementation
	protected:
		CFont* m_Font;
		void Init();
		double GetThrust(double t);
		virtual ~CRocketFormView();
		#ifdef _DEBUG
			virtual void AssertValid() const;
			virtual void Dump(CDumpContext& dc) const;
		#endif
	
		// Generated message map functions
		//{{AFX_MSG(CRocketFormView)
		afx_msg void OnChangeEngine();
		afx_msg void OnGo();
		afx_msg void OnFilePrint();
		afx_msg void CheckInputValidity();
		afx_msg void GetDensity();
		//}}AFX_MSG
		DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
